/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FlowSource type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FlowSource{}

// FlowSource Class FlowSource
type FlowSource struct {
	// Source identifier
	SourceId interface{} `json:"source_id,omitempty"`
}

// NewFlowSource instantiates a new FlowSource object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFlowSource() *FlowSource {
	this := FlowSource{}
	return &this
}

// NewFlowSourceWithDefaults instantiates a new FlowSource object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFlowSourceWithDefaults() *FlowSource {
	this := FlowSource{}
	return &this
}

// GetSourceId returns the SourceId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *FlowSource) GetSourceId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.SourceId
}

// GetSourceIdOk returns a tuple with the SourceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *FlowSource) GetSourceIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.SourceId) {
		return nil, false
	}
	return &o.SourceId, true
}

// HasSourceId returns a boolean if a field has been set.
func (o *FlowSource) HasSourceId() bool {
	if o != nil && IsNil(o.SourceId) {
		return true
	}

	return false
}

// SetSourceId gets a reference to the given interface{} and assigns it to the SourceId field.
func (o *FlowSource) SetSourceId(v interface{}) {
	o.SourceId = v
}

func (o FlowSource) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FlowSource) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.SourceId != nil {
		toSerialize["source_id"] = o.SourceId
	}
	return toSerialize, nil
}

type NullableFlowSource struct {
	value *FlowSource
	isSet bool
}

func (v NullableFlowSource) Get() *FlowSource {
	return v.value
}

func (v *NullableFlowSource) Set(val *FlowSource) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowSource) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowSource) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowSource(val *FlowSource) *NullableFlowSource {
	return &NullableFlowSource{value: val, isSet: true}
}

func (v NullableFlowSource) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowSource) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
